import StoragePlace from "../enum";
import { TSubProduct } from "../types";
import Product from "./Product";

class Fish extends Product {
    constructor(data: TSubProduct) {
        super({
            name: "Fish", 
            storageLifeDays: 20,
            deliveryTimestamp: data.deliveryTimestamp, 
            storagePlace: data.storagePlace
        });
    };

    override isFresh(): boolean {
        if(this.storagePlace === StoragePlace.Showcase) {
            this.storageLifeDays = this.storageLifeDays / 6;
        };

        const dateDifference: number = (Date.now() - this.deliveryTimestamp?.getTime()) / (1000 * 3600 * 24);

        if(dateDifference > this.storageLifeDays) {
            return false;
        } else {
            return true;
        };
    };
};

export default Fish;