import { TSubProduct } from "../types";
import Product from "./Product";

class Stew extends Product {
    constructor(data: TSubProduct) {
        super({
            name: "Stew", 
            storageLifeDays: 180,
            deliveryTimestamp: data.deliveryTimestamp, 
            storagePlace: data.storagePlace
        });
    };

    override isFresh(): boolean {
        const dateDifference: number = (Date.now() - this.deliveryTimestamp?.getTime()) / (1000 * 3600 * 24);

        if(dateDifference > this.storageLifeDays) {
            return false;
        } else {
            return true;
        };
    };
};

export default Stew;